//Class TLayout
//Daniel Garcia-Gil (danielgarciagil@gmail.com)


#include "fivewin.ch"
#include "ribbon.ch"
#include "gif.ch"
#include "ttitle.ch"


function main()
	local oWnd
	local oMainLay
	local hLays := {=>}
	local hButtons := {=>}
	local hBrowses := {=>}
	local oFld, oTitle2, oFont3

	DEFINE FONT oFont3 NAME "Blackoak Std" size 30, 60  NESCAPEMENT 900

	define window oWnd title "testing layout"

	hLays["MAIN"] = TLayout():new( oWnd )

	hLays["H1"] = hLays["MAIN"]:addHLayout(75)
	

	@  0, 0  TITLE oTitle2 size 60, 460 of hLays["H1"] SHADOW topleft SHADOWSIZE 5 Round
	hLays["H1"]:oClient = oTitle2
	oTitle2:bResized = {| nType, nWidth, nHeight |  oTitle2:atext[1][1] := ( nHeight / 2 ) + ( GetTextWidth( oWnd:hDC, oTitle2:atext[1][3], oFont3:hFont ) / 2 ) }

    @ 500, 10  TITLETEXT OF oTitle2 TEXT "LAYOUT TEST"  FONT oFont3 PEN GetStockObject( 8 )


	hLays["H2"] = hLays["MAIN"]:addHLayout()

	hLays["H2"]:addVLayout()
	hLays["H2"]:addVLayout()

	hLays["H1_1"] = hLays["H2"]:aVLayout[1]:addHLayout()
	fdx( hLays["H1_1"] )

	hLays["H1_2"] = hLays["H2"]:aVLayout[1]:addHLayout()
	brwme( hLays["H1_2"], "cust1" )


	hLays["H2_1"] = hLays["H2"]:aVLayout[2]:addHLayout()
	brwme( hLays["H2_1"], "cust2" )

	hLays["H2_2"] = hLays["H2"]:aVLayout[2]:addHLayout()
	fdx( hLays["H2_2"] )

	activate window oWnd

return nil

function brwme( oWnd, cAlias )

   local oDlg, oBrw, oFont

   USE CUSTOMER NEW SHARED ALIAS &cAlias

   @ 10, 10 XBROWSE oBrw OF oWnd SIZE 300, 200 PIXEL ;
      AUTOCOLS ALIAS alias() NOBORDER

   oBrw:nMarqueeStyle    = MARQSTYLE_HIGHLWIN7
   oBrw:CreateFromCode()

   oWnd:oClient = oBrw

return nil

function fdx( oWnd )
   local oFld, oGet, cTest := "Hello world", cAnother := "Another GET"

   @ 0, 0 FOLDEREX oFld PIXEL ;
      PROMPT "&One", "&Two", "&Three" ;
      SIZE 190, 120 OF oWnd
      
   @ 5, 1 GET oGet VAR cTest OF oFld:aDialogs[ 1 ] SIZE 120, 25 PIXEL 
   
   @ 35, 1 GET cAnother OF oFld:aDialogs[ 1 ] SIZE 120, 25 PIXEL

   oWnd:oClient = oFld

return nil

#define LAYOUT_TYPE_MAIN       0
#define LAYOUT_TYPE_HORIZONTAL 1
#define LAYOUT_TYPE_VERTICAL   2


class TLayout from TPanel
	
	data bOnResize
	data aHLayout, aVLayout
	data nType
	data nTop, nLeft, nWidth, nHeight
	data lFixed

	data nSumHFix, nHFix, nSumVFix, nVFix HIDDEN

	method new( oWnd )
	method addHLayout()
	method addVLayout()

	method calculeHorizontal( nWidth, nHeight ) HIDDEN
	method calculeVertical( nWidth, nHeight ) HIDDEN

	method onResized( nWidth, nHeight )


endclass


//----------------------------------------------------//

method TLayout:new( oWnd )

	local bOnResize

	::aHLayout  = {}
	::aVLayout  = {}

	::nTop      = 0
	::nLeft     = 0
	::nWidth    = 0
	::nHeight   = 0

	::lFixed  = .F.
	::nSumHFix = 0
	::nHFix    = 0	
	::nSumVFix = 0
	::nVFix    = 0

	::nId = ::GetNewId()

	::bOnResize = oWnd:bResized

	oWnd:bResized = {| nType, nWidth, nHeight | ::onResized( nType, nWidth, nHeight ) }

	if ! oWnd:isKindOf("TLAYOUT")
		::nType = LAYOUT_TYPE_MAIN
		oWnd:oClient = self
	endif

return ::Super:new(0,0, oWnd:nHeight, oWnd:nWidth, oWnd)

//----------------------------------------------------//

method TLayout:addVLayout( nHeight )

	local oChild

	DEFAULT nHeight := 0

	oChild = TLayout():new( self )

	oChild:nType = LAYOUT_TYPE_VERTICAL
	oChild:lFixed = nHeight > 0
	oChild:nHeight = nHeight
	
	if oChild:lFixed
		::nSumVFix++
		::nVFix += nHeight
	endif

	aadd( ::aVLayout, oChild )

return oChild

//----------------------------------------------------//

method TLayout:addHLayout( nWidth )

	local oChild

	DEFAULT nWidth := 0

	oChild = TLayout():new( self )

	oChild:nType = LAYOUT_TYPE_HORIZONTAL
	oChild:lFixed = nWidth > 0
	oChild:nWidth = nWidth
	
	if oChild:lFixed
		::nSumHFix++
		::nHFix += nWidth
	endif

	aadd( ::aHLayout, oChild )

return oChild

//----------------------------------------------------//

method TLayout:calculeVertical( nWidth, nHeight )
	local nLen
	local nNewHeight
	local nAuxHeight, nCalcHeight
	local nItem, nCountNotFixed := 0
	local nTop, nLeft
	local oItem
	local nAcum := 0

	nLen = Len( ::oWnd:aVLayout )
	nCalcHeight := ( nHeight - ::oWnd:nVFix ) / Max( 1, ( nLen - ::oWnd:nSumVFix ) )
	nNewHeight = nCalcHeight
	nTop = 0
	nLeft = 0
	for nItem = 1 to nLen
		oItem = ::oWnd:aVLayout[ nItem ]
		if oItem:nId == ::nId
			if oItem:lFixed
				nAuxHeight = nNewHeight
				nNewHeight = oItem:nHeight
			else
				nCountNotFixed++
				nNewHeight = Round( nCalcHeight * nCountNotFixed, 0 ) - nAcum
				nAuxHeight = nNewHeight
			endif
			::Move( nTop, nLeft, nWidth, nNewHeight )
			nNewHeight = nAuxHeight												
			exit
		else
			if oItem:lFixed
				nTop += oItem:nHeight
			else
				nCountNotFixed++
				nNewHeight = Round( nCalcHeight * nCountNotFixed, 0 ) - nAcum
				nAcum += nNewHeight
				nTop += nNewHeight
			endif			
		endif	
	next
return nil

//----------------------------------------------------//

method TLayout:calculeHorizontal( nWidth, nHeight )
	local nLen
	local nNewWidth
	local nAuxWidth, nCalcWidth
	local nItem, nCountNotFixed := 0
	local nTop, nLeft
	local oItem
	local nAcum := 0

	nLen = Len( ::oWnd:aHLayout )
	nCalcWidth := ( nWidth - ::oWnd:nHFix ) / Max( 1, ( nLen - ::oWnd:nSumHFix ) )
	nNewWidth = nCalcWidth
	nTop = 0
	nLeft = 0
	for nItem = 1 to nLen
		oItem = ::oWnd:aHLayout[ nItem ]
		if oItem:nId == ::nId
			if oItem:lFixed
				nAuxWidth = nNewWidth
				nNewWidth = oItem:nWidth
			else
				nCountNotFixed++
				nNewWidth = Round( nCalcWidth * nCountNotFixed, 0 ) - nAcum
				nAuxWidth = nNewWidth
			endif
			::Move( nTop, nLeft, nNewWidth, nHeight )
			nNewWidth = nAuxWidth												
			exit
		else
			if oItem:lFixed
				nLeft += oItem:nWidth
			else
				nCountNotFixed++
				nNewWidth = Round( nCalcWidth * nCountNotFixed, 0 ) - nAcum
				nAcum += nNewWidth
				nLeft += nNewWidth
			endif			
		endif	
	next
return nil

//----------------------------------------------------//

method TLayout:onResized( nType, nWidth, nHeight )
	if ::nType != LAYOUT_TYPE_MAIN
		if ::oWnd:isKindOf( "TLAYOUT" )
			switch ::nType
				case LAYOUT_TYPE_HORIZONTAL
					::calculeHorizontal( nWidth, nHeight )
					exit
				case LAYOUT_TYPE_VERTICAL
					::calculeVertical( nWidth, nHeight )
					exit
			endswitch
		endif
	end

	if ! ( ::bOnResize == NIL )
		Eval( ::bOnResize, nType, nWidth, nHeight )
	endif

return 0


//----------------------------------------------------//
